
/*

(c) 10/2007 ASkr

		DLL for MiniMeas
		Can be used directly or via ProfiLab
		
		Only an example.
		Feel free to modify (recommended ;)
		
		This is the only document my kids did not destroy...
		
*/



#include <vcl.h>
#include <windows.h>
#pragma hdrstop

#include <time.h>
#include <stdio.h>

#include <AdPort.hpp>
#include <OoMisc.hpp>

#pragma package(smart_init)
#pragma link "AdPort"
#pragma link "OoMisc"


// INPUT
#define iDEVADR  0
#define iGET_AD  1
#define iSET_PWM 2

// OUTPUT
#define oDEVADR  0
#define oRANGE	 1
#define oGET_AD  2



TApdComPort *ApdComPort1;

unsigned char dDevAdr=0;


long GetADvalue(void);
void SetPWMvalue(float value);
int OpenSerial(int Port, int Baud);




//****************************************************************************
//***
//***
//***
//****************************************************************************
#pragma argsused
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
	return 1;
}
//---------------------------------------------------------------------------



// PROFILAB
extern "C" __declspec(dllexport) unsigned char _stdcall NumInputs();
extern "C" __declspec(dllexport) unsigned char _stdcall NumOutputs();
extern "C" __declspec(dllexport) void _stdcall GetInputName(unsigned char Channel, unsigned char *Name);
extern "C" __declspec(dllexport) void _stdcall GetOutputName(unsigned char Channel, unsigned char *Name);
extern "C" __declspec(dllexport) void _stdcall CCalculate(double *PInput, double *POutput, double *PUser);
extern "C" __declspec(dllexport) void _stdcall CSimStart(double *PInput, double *POutput, double *PUser);
extern "C" __declspec(dllexport) void _stdcall CSimStop(double *PInput, double *POutput, double *PUser);
extern "C" __declspec(dllexport) void _stdcall CConfigure(double *PUser);

// UNIVERSAL
extern "C" __declspec(dllexport) _stdcall void asInit(void);
extern "C" __declspec(dllexport) _stdcall void asExit(void);
extern "C" __declspec(dllexport) _stdcall void asSetDevAdr(unsigned char Adr);
extern "C" __declspec(dllexport) _stdcall float asGetAD(void);
extern "C" __declspec(dllexport) _stdcall void asSetPWM(float value);




//****************************************************************************
//***
//***
//***
//****************************************************************************
unsigned char _stdcall NumInputs()
{
	return 3;
}


//****************************************************************************
//***
//***
//***
//****************************************************************************
unsigned char _stdcall NumOutputs()
{
	return 3;
}



//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall GetInputName(unsigned char Channel, unsigned char *Name)
{

	switch(Channel)
  {
  	case 0: strcpy(Name,"DevAdr"); break;
  	case 1: strcpy(Name,"GetAD"); break;
  	case 2: strcpy(Name,"SetPWM"); break;
    default:strcpy(Name,"ERR"); break;
  }

}



//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall GetOutputName(unsigned char Channel, unsigned char *Name)
{

	switch(Channel)
  {
  	case 0: strcpy(Name,"DevAdr"); break;
  	case 1: strcpy(Name,"ADrange"); break;
  	case 2: strcpy(Name,"ADvalue"); break;
    default:strcpy(Name,"ERR"); break;
  }
}




//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall CCalculate(double *PInput, double *POutput, double *PUser)
{
	// PInput:  Zeiger auf Eingangsdaten
	// POutput: Zeiger auf Ausgangsdaten
	// PUser:   Zeiger auf freien Speicherbereich

  unsigned char i;
  long l;
  unsigned char vl=0,vh=0,ra=0;
  float vv;


	// --- DEVICE ADDRESS ---
  if(PInput[iDEVADR] != PUser[iDEVADR])
  {
  	i=(unsigned char)PInput[iDEVADR];

		if((i<0)||(i>3))
    	i=0;

    dDevAdr=i;

  	PUser[iDEVADR]=(float)i;
    POutput[oDEVADR]=PUser[iDEVADR];

    return;
  } // END DEVICE ADDRESS


 	// --- SET_PWM ---
  if(PInput[iSET_PWM] != PUser[iSET_PWM])
  {
		PUser[iSET_PWM]=PInput[iSET_PWM];
		SetPWMvalue(PInput[iSET_PWM]);
  }


 	// --- GET_AD ---
  if(PInput[iGET_AD] != PUser[iGET_AD])
  {
  	if(PInput[iGET_AD] < PUser[iGET_AD])
    {
		  PUser[iGET_AD]=PInput[iGET_AD];
			l=GetADvalue();
    	if(l<0)
    		POutput[oGET_AD]=-1.0;
	    else
  	  {
    		vl=l & 0x007f | ((l & 0x0100) >> 1);
      	vh=(l & 0x0600) >>  9;
	      vv=256.0*vh + vl;
  	    ra=(l & 0x1800) >> 11;

	      switch(ra)
  	    {
    	  	case 0: vv*=0.002; break;
      		case 1: vv*=0.012; break;
      		case 2: vv*=0.022; break;
	      	case 3: vv*=0.032; break;
  	    }

	      POutput[oGET_AD]=vv;
  	    POutput[oRANGE]=ra;
      } // END if output valid
    } // END if input < user

	  PUser[iGET_AD]=PInput[iGET_AD];

  } // END GET_AD




}





//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall CSimStart(double *PInput, double *POutput, double *PUser)
{

	PUser[0]=0.0;
	PUser[1]=0.0;
	PUser[2]=0.0;
	PUser[3]=0.0;

	OpenSerial(2, 4800);
}



//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall CSimStop(double *PInput, double *POutput, double *PUser)
{
	ApdComPort1->Open=false;
}




//****************************************************************************
//***
//***
//***
//****************************************************************************
/*

	V E R S T E C K E N  !!!

	void CConfigure(double *PUser)
{
}

*/




//****************************************************************************
//***
//***
//***
//****************************************************************************
int OpenSerial(int Port, int Baud)
{
	ApdComPort1 = new TApdComPort(NULL);
	ApdComPort1->ComNumber = Port;
	ApdComPort1->Baud = Baud;
	ApdComPort1->Parity = pNone;
	ApdComPort1->DataBits = 8;
	ApdComPort1->StopBits = 1;
	ApdComPort1->Open = true;

	return 1;

}



//****************************************************************************
//***
//***
//***
//****************************************************************************
long GetADvalue(void)
{
	clock_t tim;

	float z;
  unsigned char i;
  unsigned char v[5];

	if(ApdComPort1->Open == false)
  	return 0.0;


  i=0x80 | (dDevAdr << 5);

	ApdComPort1->FlushInBuffer();
  ApdComPort1->PutChar(i);

	i=0;
	tim=clock();
  for(;;)
  {
		if(ApdComPort1->CharReady() == true)
    {
    	v[i]=ApdComPort1->GetChar();
      i++;
      if(i==2)
      	break;
    }
		if(clock()-tim > CLK_TCK*0.15)
			break;
	}

  if (i<2)
  	z=-1.0;
  else
	  z=256*v[0]+v[1];

  return z;

}



//****************************************************************************
//***
//***
//***
//****************************************************************************
void SetPWMvalue(float value)
{

	unsigned char vh,vl;
  unsigned char ih,il;
  float val;

	if(ApdComPort1->Open == false)
  	return;

  if(value < 0.0)
  	value=0.0;

  if(value > 3.3)
  	value=3.3;


	val=1023/3.3*value;
	ih=(unsigned char)(val/256.0);
	il=(unsigned char)(val-(256.0*ih));

	ih=ih << 1;
	if (il > 128)
  {
		il -= 128;
		ih |= 1;
  }
	ih |= dDevAdr << 5;
	ih |= 0x80;
	ih &= 0xe7;
	ih |= 8;


	ApdComPort1->PutChar(ih);
  Sleep(2);
	ApdComPort1->PutChar(il);
  Sleep(3);

}






//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall asInit(void)
{
	OpenSerial(2, 4800);
}



//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall asExit(void)
{
  ApdComPort1->Open=false;
}


//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall asSetDevAdr(unsigned char Adr)
{
	if(Adr>3)
  	Adr=3;

	dDevAdr=Adr;
}


//****************************************************************************
//***
//***
//***
//****************************************************************************
float _stdcall asGetAD()
{
	long l;
  unsigned char vl=0,vh=0,ra=0;
  float vv;

  l=GetADvalue();

 	if(l<0)
		return -1.0;

	vl=l & 0x007f | ((l & 0x0100) >> 1);
 	vh=(l & 0x0600) >>  9;
  vv=256.0*vh + vl;
  ra=(l & 0x1800) >> 11;

  switch(ra)
  {
  	case 0: vv*=0.002; break;
 		case 1: vv*=0.012; break;
 		case 2: vv*=0.022; break;
  	case 3: vv*=0.032; break;
  }

	return vv;

}




//****************************************************************************
//***
//***
//***
//****************************************************************************
void _stdcall asSetPWM(float value)
{
	SetPWMvalue(value);
}

